#include	<stdio.h>
#include	<stdlib.h>
#include	<process.h>
#include	<string.h>
#include	<jstring.h>
#include	<ctype.h>
#include	<time.h>
#include	<sys\types.h>
#include	<sys\stat.h>

#include	"zdefines.h"

#define		MAX_CHARA	180
#define		MAX_LINE	150


static boolean	_HEADER		= OFF;
static boolean	_PAGE		= OFF;
static boolean	_GAUGE		= OFF;
static boolean	_WIDE		= OFF;
static boolean	_RULE		= OFF;
static boolean	_NUMBER		= OFF;
static int		_CHARACTERS = 84 - 4;
static int		_LENGTH		= 84;
static int		_RIGHT		= 4;
static int		_LEFT		= 0;
static int		_TOPM		= 0;
static int		_SEAT		= 0;
static int		_LINES		= 55;
static int		_TAB		= 8;

static unsigned char	MSG[80];

unsigned char	pline[2][MAX_LINE][MAX_CHARA + 10];


#pragma	page()

void errout(unsigned char* msg)
{
	if (msg != NULL)		fputs(msg, stderr);
	exit(-1);
}


void helpmsg(void)
{
	fputs("Modify text-file utility PWIDE.EXE\n", stderr);
	fputs("PWIDE  3.19  93/07/30 17:38:38  T.Okazaki\n\n",
			stderr);
	fputs("gp@F\n", stderr);
	fputs("prompt>pwide [<switches>]", stderr);
	fputs(" [[<file> [<file> [<file>...]]]]\n", stderr);
	fputs("\tswitches\n", stderr);
	fprintf(stderr, "\t-C<n>\tsw(4-%d, default 84)\n", MAX_CHARA);
	fprintf(stderr, "\t-R<n>\tE}[W(4-%d, default 4)\n", MAX_CHARA - 1);
	fprintf(stderr, "\t-L<n>\t}[W(1-%d, default 0)\n", MAX_CHARA - 1);
	fprintf(stderr, "\t-U<n>\t}[W(0-%d, default 0)\n", MAX_LINE - 1);
	fprintf(stderr,
			"\t-S<n>\tV[g}[W(0-%d, default 0)\n", MAX_CHARA * 2 - 1);
	fputs("\t-M<n>\tōsw  (4-150, default 55)\n", stderr);
	fputs("\t-P\tŋ؂w\n", stderr);
	fputs("\t-H\twb_w\n", stderr);
	fputs("\t-G\tJQ[Ww\n", stderr);
	fputs("\t-W\tEigw\n", stderr);
	fputs("\t-K\t֑w\n", stderr);
	fputs("\t-N\tsԍw\n", stderr);
	fputs("\t-T\t^uJw(2-16, default 8)\n", stderr);
	fputs("WeLXgt@Cǂݍ݁AWo͂ɏo͂܂B\n", stderr);
	fputs("t@C̎wɂ̓ChJ[hgpł܂B\n", stderr);
}

int numlen(unsigned char* str)
{
	int		i;
	for (i = 0; str[i] != '\0'; i++) {
		if (str[i] < '0' || '9' < str[i])	break;
	}
	return(i);
}


boolean SetSwitch(unsigned char* sw)
{
	int		i;
	for (i = 0; sw[i] != '\0'; i++) {
		switch (tolower(sw[i])) {
			case	'h'	:	_HEADER = ON;
			case	'p'	:	_PAGE = ON;
							break;
			case	'g'	:	_GAUGE = ON;
							break;
			case	'w'	:	_WIDE = _PAGE = ON;
							break;
			case	'k'	:	_RULE = ON;
							break;
			case	'n'	:	_NUMBER = ON;
							break;
			case	'c'	:	_LENGTH = atoi(sw + i + 1);
							if (_LENGTH < 4 || MAX_CHARA < _LENGTH)
								return(FAILURE);
							i += numlen(sw + i + 1);
							break;
			case	'r'	:	_RIGHT = atoi(sw + i + 1);
							if (_RIGHT < 4 || MAX_CHARA <= _RIGHT)
								return(FAILURE);
							i += numlen(sw + i + 1);
							break;
			case	'l'	:	_LEFT = atoi(sw + i + 1);
							if (_LEFT < 1 || MAX_CHARA <= _LEFT)
								return(FAILURE);
							i += numlen(sw + i + 1);
							break;
			case	'u'	:	_TOPM = atoi(sw + i + 1);
							if (_TOPM < 0 || MAX_LINE <= _TOPM)
								return(FAILURE);
							i += numlen(sw + i + 1);
							break;
			case	's'	:	_SEAT = atoi(sw + i + 1);
							if (_SEAT < 0 || MAX_CHARA * 2 <= _SEAT)
								return(FAILURE);
							i += numlen(sw + i + 1);
							break;
			case	'm'	:	_PAGE = ON;
							_LINES = atoi(sw + i + 1);
							if (_LINES < 4 || MAX_LINE < _LINES)
								return(FAILURE);
							i += numlen(sw + i + 1);
							break;
			case	't'	:	_TAB = atoi(sw + i + 1);
							if (_TAB < 2 || 16 < _TAB)
								return(FAILURE);
							i += numlen(sw + i + 1);
							break;
			default		:	return(FAILURE);
		}
	}
	return(SUCCESS);
}

void EraseCharacter(unsigned char* str, unsigned char ch)
{
	int		i, j;
	for (i = j = 0; str[i] != '\0'; i++) {
		if (str[i] != ch)		str[j++] = str[i];
	}
	str[j] = '\0';
}

void MakeHeader(unsigned char* buffer1, unsigned char* buffer2,
				unsigned char* fname,int page)
{
	time_t		nowtime;
	time_t*		timeval;
	struct stat	buf;

	sprintf(buffer1, "Page %d  ... \"%s\".", page, fname);
	EraseCharacter(buffer1, '\n');
	if (stat(fname, &buf)) {
		time(&nowtime);
		timeval = &nowtime;
		buf.st_size = 0L;
	} else {
		timeval = &buf.st_atime;
	}
	sprintf(buffer2, "%s. %ld bytes.", ctime(timeval), buf.st_size);
	EraseCharacter(buffer2, '\n');
}

void MakeGauge(unsigned char* buffer)
{
	int				j, strcnt;
	unsigned char	k = '1';
	if (_NUMBER) {
		strcpy(buffer, "      ");
		strcnt = 6;
	} else
		strcnt = 0;
	for (j = 1; strcnt < _CHARACTERS; j++, strcnt++) {
		if (j % 10 == 5) {
			buffer[strcnt] = '+';
		} else if (! (j % 10)) {
			buffer[strcnt] = k++;
			if (k > '9')		k = '0';
		} else {
			buffer[strcnt] = '-';
		}
	}
}

void ClearPage(void)
{
	int		i;
	for (i = 0; i < MAX_LINE; i++) {
		pline[0][i][0] = '\0';
		pline[1][i][0] = '\0';
	}
}


void PageOut(void)
{
	int		i, max_line;

	for (i = max_line = 0; i < _LINES; i++) {
		if ((pline[0][i][0] != '\0') || (pline[1][i][0] != '\0')) {
				max_line = i;
		}
	}

	for (i = 0; i < _TOPM; i++)			putchar('\n');
	for (i = 0; i < max_line + 1; i++) {
		int		strcnt, j;
		for (j = 0; j < _SEAT; j++)
			putchar(' ');
		for (strcnt = 0; strcnt < _LEFT; strcnt++)
			putchar(' ');
		for (j = 0; pline[0][i][j] != '\0' && strcnt < _LENGTH - 1;
		     j++,strcnt++) {
			unsigned char	c;
			if (chkctype((c = pline[0][i][j]), 0) == CT_KJ1) {
				if (strcnt >= _LENGTH - 2) {
					break;
				} else {
					putchar(c);
					c = pline[0][i][++j];
					strcnt++;
					if (c == '\0')			break;
					putchar(c);
				}
			} else {
				putchar(c);
			}
		}
		if (pline[1][i][0] != '\0') {
			int		j;
			for (; strcnt < _LENGTH + _LEFT; strcnt++)
				putchar(' ');
			for (j = 0; pline[1][i][j] != '\0' && strcnt < _LENGTH * 2 - 1;
			     j++,strcnt++) {
				unsigned char	c;
				if (chkctype((c = pline[1][i][j]), 0) == CT_KJ1) {
					if (strcnt >= _LENGTH * 2 - 2) {
						break;
					} else {
						putchar(c);
						c = pline[1][i][++j];
						strcnt++;                        /*@@@@@@*/
						if (c == '\0')			break;
						putchar(c);
					}
				} else {
					putchar(c);
				}
			}
		}
		putchar('\n');
	}
	if (_PAGE)			putchar(0x0c);
}


int jgetc(FILE* fp, unsigned char* ch1, unsigned char* ch2)
{
	int		c;
	while ((c = getc(fp)) == 0);
	if (c == EOF) {
		*ch1 = *ch2 = 0;
		return(EOF);
	}
	*ch1 = (unsigned char)c;
	if (chkctype(*ch1, 0) == CT_KJ1) {
		while ((c = getc(fp)) == '\0');
		if (c == EOF) {
			*ch2 = 0;
			return(EOF);
		}
		*ch2 = (unsigned char)c;
	} else {
		*ch2 = 0;
	}
	return(c);
}


int RuleH(unsigned char ch1, unsigned char ch2)
{
	unsigned char	str[3];
	str[0] = ch1;
	str[1] = ch2;
	str[2] = '\0';
	if (strstr(",.CDAB", str) != NULL)
		return(1);
	else if (strstr(")]}jvtrpnlxz", str) != NULL)
		return(2);
	else
		return(0);
}

boolean RuleT(unsigned char ch1, unsigned char ch2)
{
	unsigned char	str[3];
	str[0] = ch1;
	str[1] = ch2;
	str[2] = '\0';
	if (strstr("([{usqomkigewy", str) == NULL)
		return(FALSE);
	else
		return(TRUE);
}


void ReadFile(unsigned char* fname, FILE* fp)
{
	boolean	LineFeed, BoxFeed, PageFeed, BoxHead;	/* Events */
	int				sw;
	int				page, line, column;
	unsigned int	TotalLines, FirstLine;
	unsigned char	ch1, ch2, nch1, nch2;

	LineFeed = BoxFeed = PageFeed = FALSE;
	BoxHead = TRUE;
	page = ch1 = 1;
	sw = line = column = 0;
	TotalLines = FirstLine = 0;
	ch2 = nch1 = nch2 = 0;
	ClearPage();

	jgetc(fp, &nch1, &nch2);
	while (ch1) {
		if (BoxHead) {
			if (_HEADER) {
				MakeHeader(pline[sw][line], pline[sw][line+1], fname, page);
				line += 2;
			}
			if (_GAUGE) {
				MakeGauge(pline[sw][line]);
				line++;
			}
			if (_HEADER || _GAUGE)		line++;
			FirstLine = line;
			BoxHead = FALSE;
		}
		if (! column && _NUMBER) {
			unsigned char	ln[7];
			sprintf(ln, "% 5u ", TotalLines);
			strcpy(pline[sw][line], ln);
			column = 6;
		}

		if (! nch1)					jgetc(fp, &nch1, &nch2);
		ch1 = nch1;
		ch2 = nch2;
		nch1 = nch2 = 0;
		if (ch1 == '\t') {				/*	^uR[h̏ꍇ	*/
			int		tab, i;
			tab = _TAB - column % _TAB;
			for (i = 0; i < tab && column < _CHARACTERS; i++)
				pline[sw][line][column++] = ' ';
			if (column >= _CHARACTERS) {
				pline[sw][line][column] = '\0';
				LineFeed = TRUE;
			}
		} else if (ch1 == '\n') {		/*	sR[h̏ꍇ	*/
			LineFeed = TRUE;
		} else if (ch1 == 0x0c) {		/*	ŃR[h̏ꍇ	*/
			BoxFeed = LineFeed = TRUE;
		} else if (! column && _RULE && RuleH(ch1, ch2)) { /* s֑ */
			unsigned char	kin[3];
			if (line > FirstLine) {
				int				cl;
				if (ch2)	cl = 2 + 1;
				else		cl = 1 + 1;
				if (strlen(pline[sw][line - 1]) < _LENGTH - cl) {
					kin[0] = ch1;
					kin[1] = ch2;
					kin[2] = '\0';
					strcat(pline[sw][line - 1], kin);
				} else {
					pline[sw][line][column++] = ch1;
					if (ch2)	pline[sw][line][column++] = ch2;
				}
			} else if (line == FirstLine && sw) {
				int		cl;
				if (ch2)	cl = 2 + 1;
				else		cl = 1 + 1;
				if (strlen(pline[0][_LINES - 1]) < _LENGTH - cl) {
					kin[0] = ch1;
					kin[1] = ch2;
					kin[2] = '\0';
					strcat(pline[0][_LINES - 1], kin);
				} else {
					pline[sw][line][column++] = ch1;
					if (ch2)	pline[sw][line][column++] = ch2;
				}
			} else if (RuleH(ch1, ch2) == 2) {		/* ʂɑ΂鏈 */
				pline[sw][line][column++] = ch1;
				if (ch2)	pline[sw][line][column++] = ch2;
			}
			{
				char	ch3;
				ch3 = getc(fp);
				if (ch3 != '\n')	ungetc(ch3, fp);
			}
		} else if (									/* s֑ */
			(_RULE && RuleT(ch1, ch2)) &&
			((column==_CHARACTERS-1 && !ch2)||(column==_CHARACTERS-2 && ch2))
		) {
			pline[sw][line][column] = '\0';
			nch1 = ch1;
			nch2 = ch2;
			LineFeed = TRUE;
		} else if ((column == _CHARACTERS -1) && ch2) {	/* R[h */
				nch1 = ch1;
				nch2 = ch2;
				LineFeed = TRUE;
		} else {
			pline[sw][line][column++] = ch1;
			if (ch2)	pline[sw][line][column++] = ch2;
			if (column >= _CHARACTERS) {
				char	ch3;
				ch3 = getc(fp);
				if (ch3 != '\n')	ungetc(ch3, fp);
				pline[sw][line][column] = '\0';
				LineFeed = TRUE;
			}
		}


		if (LineFeed) {
			pline[sw][line++][column] = '\0';
			TotalLines++;
			column = 0;
			if (line >= _LINES)		BoxFeed = TRUE;
			LineFeed = 0;
		}
		if (BoxFeed) {
			line = column = 0;
			if (sw) {
				sw = 0;
				PageFeed = TRUE;
			} else {
				if (_WIDE)
					sw = 1;
				else
					PageFeed = TRUE;
			}
			page++;
			BoxFeed = FALSE;
			BoxHead = TRUE;
		}
		if (PageFeed) {
			PageOut();
			ClearPage();
			PageFeed = FALSE;
		}
	}
	PageOut();
}


void main(int argc, char* argv[])
{
	int		i;
	boolean	existfile = FALSE;

	if (argc < 2) {
		helpmsg();
		errout(NULL);
	}

	for (i = 1; i < argc; i++) {
		if (argv[i][0] == '-' || argv[i][0] == '/') {
			if (SetSwitch(argv[i] + 1)) {
				sprintf(MSG, "Illegal switch \"%s\".\n", argv[i]);
				errout(MSG);
			}
		}
	}
	
	_CHARACTERS = _LENGTH - _RIGHT - _LEFT;
	_LINES      -= _TOPM;
	if (_CHARACTERS < 4)		errout("Illegal format.\n");

	for (i = 1; i < argc; i++) {
		if (argv[i][0] != '-' && argv[i][0] != '/') {
			FILE*	fp;
			if ((fp = fopen(argv[i], "r")) == NULL) {
				sprintf(MSG, "Cannot open a file \"%s\".\n", argv[i]);
				errout(MSG);
			}
			ReadFile(argv[i], fp);
			fclose(fp);
			existfile = TRUE;
		}
	}
	if (! existfile) {
		ReadFile("Standard Input",  stdin);
	}

	exit(SUCCESS);
}

